diff --git a/pki/base/common/src/com/netscape/cmscore/security/PWsdrCache.java b/pki/base/common/src/com/netscape/cmscore/security/PWsdrCache.java
index 3d57c6276d9a2f2e32689fb5790f0af097052f7a..e0fe0252d9911b5cade6403a4e848f0216cae88a 100644
--- a/pki/base/common/src/com/netscape/cmscore/security/PWsdrCache.java
+++ b/pki/base/common/src/com/netscape/cmscore/security/PWsdrCache.java
@@ -217,20 +217,20 @@ public class PWsdrCache {
     }
 
     public void addEntry(String tag, String pwd) throws EBaseException {
-        addEntry(tag, pwd, (Hashtable) null);
+        addEntry(tag, pwd, (Hashtable<String, String>) null);
     }
 
     /*
      * Store passwd in pwcache.
      */
-    public void addEntry(Hashtable ht) throws EBaseException {
+    public void addEntry(Hashtable<String, String> ht) throws EBaseException {
         addEntry((String) null, (String) null, ht);
     }
 
     /*
      * add passwd in pwcache.
      */
-    public void addEntry(String tag, String pwd, Hashtable tagPwds) throws EBaseException {
+    public void addEntry(String tag, String pwd, Hashtable<String, String> tagPwds) throws EBaseException {
 
         String stringToAdd = null;
         String bufs = null;
@@ -238,11 +238,11 @@ public class PWsdrCache {
         if (tagPwds == null) {
             stringToAdd = tag + ":" + pwd + "\n";
         } else {
-            Enumeration enum1 = tagPwds.keys();
+            Enumeration<String> enum1 = tagPwds.keys();
 
             while (enum1.hasMoreElements()) {
-                tag = (String) enum1.nextElement();
-                pwd = (String) tagPwds.get(tag);
+                tag = enum1.nextElement();
+                pwd = tagPwds.get(tag);
                 debug("password tag: " + tag + " stored in " + mPWcachedb);
 
                 if (stringToAdd == null) {
@@ -435,13 +435,13 @@ public class PWsdrCache {
         }
     }
 
-    public String hashtable2String(Hashtable ht) {
-        Enumeration enum1 = ht.keys();
+    public String hashtable2String(Hashtable<String, String> ht) {
+        Enumeration<String> enum1 = ht.keys();
         String returnString = null;
 
         while (enum1.hasMoreElements()) {
-            String tag = (String) enum1.nextElement();
-            String pwd = (String) ht.get(tag);
+            String tag = enum1.nextElement();
+            String pwd = ht.get(tag);
 
             if (returnString == null) {
                 returnString = tag + ":" + pwd + "\n";
@@ -452,8 +452,8 @@ public class PWsdrCache {
         return returnString;
     }
 
-    public Hashtable string2Hashtable(String cache) {
-        Hashtable ht = new Hashtable();
+    public Hashtable<String, String> string2Hashtable(String cache) {
+        Hashtable<String, String> ht = new Hashtable<String, String>();
 
         // first, break into lines
         StringTokenizer st = new StringTokenizer(cache, "\n");
diff --git a/pki/base/common/test/com/netscape/certsrv/request/AgentApprovalsTest.java b/pki/base/common/test/com/netscape/certsrv/request/AgentApprovalsTest.java
index 0cd27840d5d9241e52efa0a14b2a6de4380dd8dd..8770dca2bb9d9fb827f77c9cf04021a85e364464 100644
--- a/pki/base/common/test/com/netscape/certsrv/request/AgentApprovalsTest.java
+++ b/pki/base/common/test/com/netscape/certsrv/request/AgentApprovalsTest.java
@@ -34,7 +34,7 @@ public class AgentApprovalsTest extends CMSBaseTestCase {
         agentApprovals.mVector.add(approval2);
         agentApprovals.mVector.add(approval3);
 
-        Vector stringVector = agentApprovals.toStringVector();
+        Vector<String> stringVector = agentApprovals.toStringVector();
         assertNotNull(stringVector);
         assertEquals(3, stringVector.size());
         assertEquals(approval1.getDate().getTime() + ";" + approval1.getUserName(),
diff --git a/pki/base/common/test/com/netscape/cmscore/dbs/DBRegistryTest.java b/pki/base/common/test/com/netscape/cmscore/dbs/DBRegistryTest.java
index b76cfd78c53ee93616c8f0619c40875bdfc2ca69..c74f66ba1aedaa8992485610a898b07b0153337e 100644
--- a/pki/base/common/test/com/netscape/cmscore/dbs/DBRegistryTest.java
+++ b/pki/base/common/test/com/netscape/cmscore/dbs/DBRegistryTest.java
@@ -168,7 +168,7 @@ class RequestRecordStub extends RequestRecordDefaultStub {
         return "foo";
     }
 
-    public Enumeration getSerializableAttrNames() {
+    public Enumeration<String> getSerializableAttrNames() {
         getSerializedAttrNamesCalled = true;
         return Collections.enumeration(Arrays.asList(attrs));
     }
diff --git a/pki/base/common/test/com/netscape/cmscore/request/DBDynAttrMapperDefaultStub.java b/pki/base/common/test/com/netscape/cmscore/request/DBDynAttrMapperDefaultStub.java
index 6f3bf7fe3fcb275a35196b616aebdf6b297f8811..cccbe600ff7152158bead91654d9084de6f4e093 100644
--- a/pki/base/common/test/com/netscape/cmscore/request/DBDynAttrMapperDefaultStub.java
+++ b/pki/base/common/test/com/netscape/cmscore/request/DBDynAttrMapperDefaultStub.java
@@ -16,7 +16,7 @@ public class DBDynAttrMapperDefaultStub implements IDBDynAttrMapper {
         return false;
     }
 
-    public Enumeration getSupportedLDAPAttributeNames() {
+    public Enumeration<String> getSupportedLDAPAttributeNames() {
         return null;
     }
 
diff --git a/pki/base/java-tools/src/com/netscape/cmstools/PasswordCache.java b/pki/base/java-tools/src/com/netscape/cmstools/PasswordCache.java
index ae0af3d44f4157d764241c9ad777721d10499c5a..470e06cf900d56df37ddf5065700091b981780f8 100644
--- a/pki/base/java-tools/src/com/netscape/cmstools/PasswordCache.java
+++ b/pki/base/java-tools/src/com/netscape/cmstools/PasswordCache.java
@@ -431,20 +431,20 @@ class PWsdrCache {
     }
 
     public void addEntry(String tag, String pwd) throws IOException {
-        addEntry(tag, pwd, (Hashtable) null);
+        addEntry(tag, pwd, (Hashtable<String, String>) null);
     }
 
     /*
      * Store passwd in pwcache.
      */
-    public void addEntry(Hashtable ht) throws IOException {
+    public void addEntry(Hashtable<String, String> ht) throws IOException {
         addEntry((String) null, (String) null, ht);
     }
 
     /*
      * add passwd in pwcache.
      */
-    public void addEntry(String tag, String pwd, Hashtable tagPwds) throws IOException {
+    public void addEntry(String tag, String pwd, Hashtable<String, String> tagPwds) throws IOException {
         System.out.println("PWsdrCache: in addEntry");
         String stringToAdd = null;
         String bufs = null;
@@ -452,11 +452,11 @@ class PWsdrCache {
         if (tagPwds == null) {
             stringToAdd = tag + ":" + pwd + "\n";
         } else {
-            Enumeration enum1 = tagPwds.keys();
+            Enumeration<String> enum1 = tagPwds.keys();
 
             while (enum1.hasMoreElements()) {
-                tag = (String) enum1.nextElement();
-                pwd = (String) tagPwds.get(tag);
+                tag = enum1.nextElement();
+                pwd = tagPwds.get(tag);
                 debug("password tag: " + tag + " stored in " + mPWcachedb);
 
                 if (stringToAdd == null) {
@@ -472,7 +472,7 @@ class PWsdrCache {
         if (dcrypts != null) {
             // converts to Hashtable, replace if tag exists, add
             //                if tag doesn't exist
-            Hashtable ht = string2Hashtable(dcrypts);
+            Hashtable<String, String> ht = string2Hashtable(dcrypts);
 
             if (ht.containsKey(tag) == false) {
                 debug("adding new tag: " + tag);
@@ -502,7 +502,7 @@ class PWsdrCache {
         if (dcrypts != null) {
             // converts to Hashtable, replace if tag exists, add
             //                if tag doesn't exist
-            Hashtable ht = string2Hashtable(dcrypts);
+            Hashtable<String, String> ht = string2Hashtable(dcrypts);
 
             if (ht.containsKey(tag) == false) {
                 debug("tag: " + tag + " does not exist");
@@ -673,13 +673,13 @@ class PWsdrCache {
         }
     }
 
-    public String hashtable2String(Hashtable ht) {
-        Enumeration enum1 = ht.keys();
+    public String hashtable2String(Hashtable<String, String> ht) {
+        Enumeration<String> enum1 = ht.keys();
         String returnString = null;
 
         while (enum1.hasMoreElements()) {
-            String tag = (String) enum1.nextElement();
-            String pwd = (String) ht.get(tag);
+            String tag = enum1.nextElement();
+            String pwd = ht.get(tag);
 
             if (returnString == null) {
                 returnString = tag + ":" + pwd + "\n";
@@ -690,8 +690,8 @@ class PWsdrCache {
         return returnString;
     }
 
-    public Hashtable string2Hashtable(String cache) {
-        Hashtable ht = new Hashtable();
+    public Hashtable<String, String> string2Hashtable(String cache) {
+        Hashtable<String, String> ht = new Hashtable<String, String>();
 
         // first, break into lines
         StringTokenizer st = new StringTokenizer(cache, "\n");
@@ -727,7 +727,7 @@ class PWsdrCache {
      * if tag not found, return null, which will cause it to give up
      */
     public Password getEntry(String tag) {
-        Hashtable pwTable = null;
+        Hashtable<String, String> pwTable = null;
         String pw = null;
 
         debug("in getEntry, tag=" + tag);
diff --git a/pki/base/ocsp/src/com/netscape/ocsp/OCSPAuthority.java b/pki/base/ocsp/src/com/netscape/ocsp/OCSPAuthority.java
index c4d77c783b0f2738bd8cc3fac5f32583eb91c5b8..91763ed83f023b8345f38e145914b53d981ae94b 100644
--- a/pki/base/ocsp/src/com/netscape/ocsp/OCSPAuthority.java
+++ b/pki/base/ocsp/src/com/netscape/ocsp/OCSPAuthority.java
@@ -140,7 +140,7 @@ public class OCSPAuthority implements IOCSPAuthority, IOCSPService, ISubsystem,
                 }
 
                 IConfigStore storeConfig = mConfig.getSubStore(PROP_STORE);
-                Enumeration ids = storeConfig.getSubStoreNames();
+                Enumeration<String> ids = storeConfig.getSubStoreNames();
 
                 while (ids.hasMoreElements()) {
                     String id = (String) ids.nextElement();
diff --git a/pki/base/util/src/com/netscape/cmsutil/http/HttpMessage.java b/pki/base/util/src/com/netscape/cmsutil/http/HttpMessage.java
index 100cbb5af80e44523e4e757ecf37a71c9ad17f31..badec5930a0abed879d1e46be1d5314de2a242c9 100644
--- a/pki/base/util/src/com/netscape/cmsutil/http/HttpMessage.java
+++ b/pki/base/util/src/com/netscape/cmsutil/http/HttpMessage.java
@@ -30,14 +30,14 @@ import java.util.Hashtable;
  */
 public class HttpMessage {
     protected String mLine = null; // request or response line.
-    protected Hashtable mHeaders = null;
+    protected Hashtable<String, String> mHeaders = null;
     protected String mContent = null; // arbitrary content chars assumed.
 
     /**
      * Instantiate a HttpResponse for write to http client.
      */
     public HttpMessage() {
-        mHeaders = new Hashtable();
+        mHeaders = new Hashtable<String, String>();
     }
 
     /**
@@ -48,7 +48,7 @@ public class HttpMessage {
      */
     public void setHeader(String name, String value) {
         if (mHeaders == null)
-            mHeaders = new Hashtable();
+            mHeaders = new Hashtable<String, String>();
         mHeaders.put(name.toLowerCase(), value);
     }
 
@@ -66,12 +66,12 @@ public class HttpMessage {
     public void writeHeaders(OutputStreamWriter writer)
             throws IOException {
         if (mHeaders != null) {
-            Enumeration keys = mHeaders.keys();
+            Enumeration<String> keys = mHeaders.keys();
             String header, value;
 
             while (keys.hasMoreElements()) {
-                header = (String) keys.nextElement();
-                value = (String) mHeaders.get(header);
+                header = keys.nextElement();
+                value = mHeaders.get(header);
                 writer.write(header + ":" + value + Http.CRLF);
             }
         }
@@ -84,7 +84,7 @@ public class HttpMessage {
      */
     public void readHeaders(BufferedReader reader)
             throws IOException {
-        mHeaders = new Hashtable();
+        mHeaders = new Hashtable<String, String>();
 
         int colon;
         String line, key, value;
@@ -129,7 +129,7 @@ public class HttpMessage {
         readHeaders(reader);
 
         // won't work if content length is not set.
-        String lenstr = (String) mHeaders.get("content-length");
+        String lenstr = mHeaders.get("content-length");
 
         if (lenstr != null) {
             int len = Integer.parseInt(lenstr);
diff --git a/pki/base/util/src/com/netscape/cmsutil/radius/AttributeSet.java b/pki/base/util/src/com/netscape/cmsutil/radius/AttributeSet.java
index 46860de19c88e048225b3545d6c3abf2fbcb39b4..d6974d37144b64fad7dffd0c2a2924424670d657 100644
--- a/pki/base/util/src/com/netscape/cmsutil/radius/AttributeSet.java
+++ b/pki/base/util/src/com/netscape/cmsutil/radius/AttributeSet.java
@@ -21,7 +21,7 @@ import java.util.Enumeration;
 import java.util.Vector;
 
 public class AttributeSet {
-    private Vector _attrs = new Vector();
+    private Vector<Attribute> _attrs = new Vector<Attribute>();
 
     public AttributeSet() {
     }
@@ -34,7 +34,7 @@ public class AttributeSet {
         return _attrs.size();
     }
 
-    public Enumeration getAttributes() {
+    public Enumeration<Attribute> getAttributes() {
         return _attrs.elements();
     }
 
@@ -51,6 +51,6 @@ public class AttributeSet {
     }
 
     public Attribute getAttributeAt(int pos) {
-        return (Attribute) _attrs.elementAt(pos);
+        return _attrs.elementAt(pos);
     }
 }
diff --git a/pki/base/util/src/com/netscape/cmsutil/xml/XMLObject.java b/pki/base/util/src/com/netscape/cmsutil/xml/XMLObject.java
index 8890d79fed3f001bfe4105667f72c68a97ef0c12..8317ad785f8773631507f2d89231cf1cebbfd417 100644
--- a/pki/base/util/src/com/netscape/cmsutil/xml/XMLObject.java
+++ b/pki/base/util/src/com/netscape/cmsutil/xml/XMLObject.java
@@ -137,8 +137,8 @@ public class XMLObject {
         return v;
     }
 
-    public Vector getValuesFromContainer(Node container, String tagname) {
-        Vector v = new Vector();
+    public Vector<String> getValuesFromContainer(Node container, String tagname) {
+        Vector<String> v = new Vector<String>();
         NodeList c = container.getChildNodes();
         int len = c.getLength();
         for (int i = 0; i < len; i++) {
diff --git a/pki/base/util/src/netscape/security/acl/GroupImpl.java b/pki/base/util/src/netscape/security/acl/GroupImpl.java
index fc50714f8fa0ab350fb3d28f524fc872ec3029ee..ed087a54487d8b6d7f31e1aaf66adff8c6c91ad2 100644
--- a/pki/base/util/src/netscape/security/acl/GroupImpl.java
+++ b/pki/base/util/src/netscape/security/acl/GroupImpl.java
@@ -28,7 +28,7 @@ import java.util.Vector;
  * @author Satish Dharmaraj
  */
 public class GroupImpl implements Group {
-    private Vector groupMembers = new Vector(50, 100);
+    private Vector<Principal> groupMembers = new Vector<Principal>(50, 100);
     private String group;
 
     /**
@@ -73,7 +73,7 @@ public class GroupImpl implements Group {
     /**
      * returns the enumeration of the members in the group.
      */
-    public Enumeration members() {
+    public Enumeration<Principal> members() {
         return groupMembers.elements();
     }
 
@@ -118,7 +118,7 @@ public class GroupImpl implements Group {
         if (groupMembers.contains(member)) {
             return true;
         } else {
-            Vector alreadySeen = new Vector(10);
+            Vector<Group> alreadySeen = new Vector<Group>(10);
             return isMemberRecurse(member, alreadySeen);
         }
     }
@@ -136,11 +136,11 @@ public class GroupImpl implements Group {
     // a vector of already seen groups. Only new groups are considered, 
     // thereby avoiding loops.
     //
-    boolean isMemberRecurse(Principal member, Vector alreadySeen) {
-        Enumeration e = members();
+    boolean isMemberRecurse(Principal member, Vector<Group> alreadySeen) {
+        Enumeration<Principal> e = members();
         while (e.hasMoreElements()) {
             boolean mem = false;
-            Principal p = (Principal) e.nextElement();
+            Principal p = e.nextElement();
 
             // if the member is in this collection, return true
             if (p.equals(member)) {
diff --git a/pki/base/util/src/netscape/security/pkcs/PKCS10Attributes.java b/pki/base/util/src/netscape/security/pkcs/PKCS10Attributes.java
index 46b309cc772240dc1194c14cfdd19b8e03d8442a..8beb1e64cbc4ae34b5abccb986159aa8690f2e75 100644
--- a/pki/base/util/src/netscape/security/pkcs/PKCS10Attributes.java
+++ b/pki/base/util/src/netscape/security/pkcs/PKCS10Attributes.java
@@ -35,19 +35,19 @@ import netscape.security.util.DerValue;
  * @author Hemma Prafullchandra
  * @version 1.10
  */
-public class PKCS10Attributes extends Vector implements DerEncoder {
+public class PKCS10Attributes extends Vector<PKCS10Attribute> implements DerEncoder {
 
     /**
      *
      */
     private static final long serialVersionUID = 1362260612357629542L;
-    private Hashtable map;
+    private Hashtable<String, PKCS10Attribute> map;
 
     /**
      * Default constructor for the certificate attribute.
      */
     public PKCS10Attributes() {
-        map = new Hashtable();
+        map = new Hashtable<String, PKCS10Attribute>();
     }
 
     /**
@@ -59,7 +59,7 @@ public class PKCS10Attributes extends Vector implements DerEncoder {
     public PKCS10Attributes(DerInputStream in)
             throws IOException {
 
-        map = new Hashtable();
+        map = new Hashtable<String, PKCS10Attribute>();
         DerValue[] attrs = in.getSet(5, true);
 
         if (attrs != null) {
@@ -107,41 +107,41 @@ public class PKCS10Attributes extends Vector implements DerEncoder {
     /**
      * Set the attribute value.
      */
-    public void setAttribute(String name, Object obj) throws IOException {
-        map.put(name, obj);
-        addElement(obj);
+    public void setAttribute(String name, PKCS10Attribute attr) throws IOException {
+        map.put(name, attr);
+        addElement(attr);
     }
 
     /**
      * Get the attribute value.
      */
-    public Object getAttribute(String name) throws IOException {
-        Object obj = map.get(name);
+    public PKCS10Attribute getAttribute(String name) throws IOException {
+        PKCS10Attribute attr = map.get(name);
         /*
-        if (obj == null) {
+        if (attr == null) {
             throw new IOException("No attribute found with name " + name);
         }
         */
-        return (obj);
+        return (attr);
     }
 
     /**
      * Delete the attribute value.
      */
     public void deleteAttribute(String name) throws IOException {
-        Object obj = map.get(name);
-        if (obj == null) {
+        PKCS10Attribute attr = map.get(name);
+        if (attr == null) {
             throw new IOException("No attribute found with name " + name);
         }
         map.remove(name);
-        removeElement(obj);
+        removeElement(attr);
     }
 
     /**
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration getElements() {
-        return (map.elements());
+    public Enumeration<PKCS10Attribute> getElements() {
+        return map.elements();
     }
 }
diff --git a/pki/base/util/src/netscape/security/x509/Attribute.java b/pki/base/util/src/netscape/security/x509/Attribute.java
index b026e30c349bad04d0aec94a6a53f6505b104a7c..11e22db10d833583b9f53cebac059ea824a9f19c 100644
--- a/pki/base/util/src/netscape/security/x509/Attribute.java
+++ b/pki/base/util/src/netscape/security/x509/Attribute.java
@@ -64,7 +64,7 @@ public final class Attribute implements Serializable, DerEncoder {
     private static final long serialVersionUID = -931486084625476764L;
     //private variables
     ObjectIdentifier oid;
-    Vector valueSet = new Vector();
+    Vector<String> valueSet = new Vector<String>();
     transient protected X500NameAttrMap attrMap;
 
     //========== CONSTRUCTOR ==================================
@@ -93,7 +93,7 @@ public final class Attribute implements Serializable, DerEncoder {
      * @param oid the object identifier of the attribute type
      * @param values String value vector
      */
-    public Attribute(ObjectIdentifier oid, Vector values)
+    public Attribute(ObjectIdentifier oid, Vector<String> values)
             throws IOException {
 
         //pre-condition verification
@@ -104,13 +104,9 @@ public final class Attribute implements Serializable, DerEncoder {
         this.oid = oid;
 
         //copy the value into the valueSet list
-        Enumeration vals = values.elements();
+        Enumeration<String> vals = values.elements();
         while (vals.hasMoreElements()) {
-            Object obj = vals.nextElement();
-            if (obj instanceof String)
-                valueSet.addElement(obj);
-            else
-                throw new IOException("values vectore must consist of String object");
+            valueSet.addElement(vals.nextElement());
         }
     }
 
@@ -120,7 +116,7 @@ public final class Attribute implements Serializable, DerEncoder {
      * @param oid attribute type string CN,OU,O,C,L,TITLE,ST,STREET,UID,MAIL,E,DC
      * @param values String value vector
      */
-    public Attribute(String attr, Vector values)
+    public Attribute(String attr, Vector<String> values)
             throws IOException {
 
         //pre-condition verification
@@ -143,13 +139,9 @@ public final class Attribute implements Serializable, DerEncoder {
         this.oid = id;
 
         //copy the value into the valueSet list
-        Enumeration vals = values.elements();
+        Enumeration<String> vals = values.elements();
         while (vals.hasMoreElements()) {
-            Object obj = vals.nextElement();
-            if (obj instanceof String)
-                valueSet.addElement(obj);
-            else
-                throw new IOException("Values vectore must consist of String object");
+            valueSet.addElement(vals.nextElement());
         }
     }
 
@@ -188,7 +180,7 @@ public final class Attribute implements Serializable, DerEncoder {
      * 
      * @return Enumeration of values of this Attribute.
      */
-    public Enumeration getValues() {
+    public Enumeration<String> getValues() {
         if (valueSet == null)
             return null;
         return valueSet.elements();
@@ -223,11 +215,11 @@ public final class Attribute implements Serializable, DerEncoder {
     public String toString() {
         String theoid = "Attribute: " + oid + "\n";
         String values = "Values: ";
-        Enumeration n = valueSet.elements();
+        Enumeration<String> n = valueSet.elements();
         if (n.hasMoreElements()) {
-            values += (String) n.nextElement();
+            values += n.nextElement();
             while (n.hasMoreElements())
-                values += "," + (String) n.nextElement();
+                values += "," + n.nextElement();
         }
         return theoid + values + "\n";
     }
@@ -260,9 +252,9 @@ public final class Attribute implements Serializable, DerEncoder {
         }
 
         //loop through all the values and encode
-        Enumeration vals = valueSet.elements();
+        Enumeration<String> vals = valueSet.elements();
         while (vals.hasMoreElements()) {
-            String val = (String) vals.nextElement();
+            String val = vals.nextElement();
             DerValue derobj = converter.getValue(val);
             derobj.encode(tmp);
         }
-- 
1.7.5.1

